# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2017_09_01_preview
  module Models
    #
    # Information about an activity run in a pipeline.
    #
    class ActivityRun

      include MsRestAzure

      # @return Unmatched properties from the message are deserialized this
      # collection
      attr_accessor :additional_properties

      # @return [String] The name of the pipeline.
      attr_accessor :pipeline_name

      # @return [String] The id of the pipeline run.
      attr_accessor :pipeline_run_id

      # @return [String] The name of the activity.
      attr_accessor :activity_name

      # @return [String] The type of the activity.
      attr_accessor :activity_type

      # @return [String] The id of the activity run.
      attr_accessor :activity_run_id

      # @return [String] The name of the compute linked service.
      attr_accessor :linked_service_name

      # @return [String] The status of the activity run.
      attr_accessor :status

      # @return [DateTime] The start time of the activity run in 'ISO 8601'
      # format.
      attr_accessor :activity_run_start

      # @return [DateTime] The end time of the activity run in 'ISO 8601'
      # format.
      attr_accessor :activity_run_end

      # @return [Integer] The duration of the activity run.
      attr_accessor :duration_in_ms

      # @return The input for the activity.
      attr_accessor :input

      # @return The output for the activity.
      attr_accessor :output

      # @return The error if any from the activity run.
      attr_accessor :error


      #
      # Mapper for ActivityRun class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ActivityRun',
          type: {
            name: 'Composite',
            class_name: 'ActivityRun',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              pipeline_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'pipelineName',
                type: {
                  name: 'String'
                }
              },
              pipeline_run_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'pipelineRunId',
                type: {
                  name: 'String'
                }
              },
              activity_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'activityName',
                type: {
                  name: 'String'
                }
              },
              activity_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'activityType',
                type: {
                  name: 'String'
                }
              },
              activity_run_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'activityRunId',
                type: {
                  name: 'String'
                }
              },
              linked_service_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'linkedServiceName',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              activity_run_start: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'activityRunStart',
                type: {
                  name: 'DateTime'
                }
              },
              activity_run_end: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'activityRunEnd',
                type: {
                  name: 'DateTime'
                }
              },
              duration_in_ms: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'durationInMs',
                type: {
                  name: 'Number'
                }
              },
              input: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'input',
                type: {
                  name: 'Object'
                }
              },
              output: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'output',
                type: {
                  name: 'Object'
                }
              },
              error: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'error',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
