# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2017_09_01_preview
  module Models
    #
    # Linked service for MongoDb data source.
    #
    class MongoDbLinkedService < LinkedService

      include MsRestAzure


      def initialize
        @type = "MongoDb"
      end

      attr_accessor :type

      # @return The IP address or server name of the MongoDB server. Type:
      # string (or Expression with resultType string).
      attr_accessor :server

      # @return [MongoDbAuthenticationType] The authentication type to be used
      # to connect to the MongoDB database. Possible values include: 'Basic',
      # 'Anonymous'
      attr_accessor :authentication_type

      # @return The name of the MongoDB database that you want to access. Type:
      # string (or Expression with resultType string).
      attr_accessor :database_name

      # @return Username for authentication. Type: string (or Expression with
      # resultType string).
      attr_accessor :username

      # @return [SecretBase] Password for authentication.
      attr_accessor :password

      # @return Database to verify the username and password. Type: string (or
      # Expression with resultType string).
      attr_accessor :auth_source

      # @return The TCP port number that the MongoDB server uses to listen for
      # client connections. The default value is 27017. Type: integer (or
      # Expression with resultType integer), minimum: 0.
      attr_accessor :port

      # @return Specifies whether the connections to the server are encrypted
      # using SSL. The default value is false. Type: boolean (or Expression
      # with resultType boolean).
      attr_accessor :enable_ssl

      # @return Specifies whether to allow self-signed certificates from the
      # server. The default value is false. Type: boolean (or Expression with
      # resultType boolean).
      attr_accessor :allow_self_signed_server_cert

      # @return The encrypted credential used for authentication. Credentials
      # are encrypted using the integration runtime credential manager. Type:
      # string (or Expression with resultType string).
      attr_accessor :encrypted_credential


      #
      # Mapper for MongoDbLinkedService class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'MongoDb',
          type: {
            name: 'Composite',
            class_name: 'MongoDbLinkedService',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              connect_via: {
                client_side_validation: true,
                required: false,
                serialized_name: 'connectVia',
                type: {
                  name: 'Composite',
                  class_name: 'IntegrationRuntimeReference'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParameterSpecificationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParameterSpecification'
                      }
                  }
                }
              },
              annotations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'annotations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              server: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.server',
                type: {
                  name: 'Object'
                }
              },
              authentication_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.authenticationType',
                type: {
                  name: 'String'
                }
              },
              database_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.databaseName',
                type: {
                  name: 'Object'
                }
              },
              username: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.username',
                type: {
                  name: 'Object'
                }
              },
              password: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.password',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              auth_source: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.authSource',
                type: {
                  name: 'Object'
                }
              },
              port: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.port',
                type: {
                  name: 'Object'
                }
              },
              enable_ssl: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.enableSsl',
                type: {
                  name: 'Object'
                }
              },
              allow_self_signed_server_cert: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.allowSelfSignedServerCert',
                type: {
                  name: 'Object'
                }
              },
              encrypted_credential: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.encryptedCredential',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
