# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2017_09_01_preview
  module Models
    #
    # QuickBooks server linked service.
    #
    class QuickBooksLinkedService < LinkedService

      include MsRestAzure


      def initialize
        @type = "QuickBooks"
      end

      attr_accessor :type

      # @return The endpoint of the QuickBooks server. (i.e.
      # quickbooks.api.intuit.com)
      attr_accessor :endpoint

      # @return The company ID of the QuickBooks company to authorize.
      attr_accessor :company_id

      # @return The consumer key for OAuth 1.0 authentication.
      attr_accessor :consumer_key

      # @return [SecretBase] The consumer secret for OAuth 1.0 authentication.
      attr_accessor :consumer_secret

      # @return [SecretBase] The access token for OAuth 1.0 authentication.
      attr_accessor :access_token

      # @return [SecretBase] The access token secret for OAuth 1.0
      # authentication.
      attr_accessor :access_token_secret

      # @return Specifies whether the data source endpoints are encrypted using
      # HTTPS. The default value is true.
      attr_accessor :use_encrypted_endpoints

      # @return The encrypted credential used for authentication. Credentials
      # are encrypted using the integration runtime credential manager. Type:
      # string (or Expression with resultType string).
      attr_accessor :encrypted_credential


      #
      # Mapper for QuickBooksLinkedService class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'QuickBooks',
          type: {
            name: 'Composite',
            class_name: 'QuickBooksLinkedService',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              connect_via: {
                client_side_validation: true,
                required: false,
                serialized_name: 'connectVia',
                type: {
                  name: 'Composite',
                  class_name: 'IntegrationRuntimeReference'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParameterSpecificationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParameterSpecification'
                      }
                  }
                }
              },
              annotations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'annotations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              endpoint: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.endpoint',
                type: {
                  name: 'Object'
                }
              },
              company_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.companyId',
                type: {
                  name: 'Object'
                }
              },
              consumer_key: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.consumerKey',
                type: {
                  name: 'Object'
                }
              },
              consumer_secret: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.consumerSecret',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              access_token: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.accessToken',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              access_token_secret: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.accessTokenSecret',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              use_encrypted_endpoints: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.useEncryptedEndpoints',
                type: {
                  name: 'Object'
                }
              },
              encrypted_credential: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.encryptedCredential',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
