# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Trigger that runs every time a custom event is received.
    #
    class CustomEventsTrigger < MultiplePipelineTrigger

      include MsRestAzure


      def initialize
        @type = "CustomEventsTrigger"
      end

      attr_accessor :type

      # @return [String] The event subject must begin with the pattern provided
      # for trigger to fire. At least one of these must be provided:
      # subjectBeginsWith, subjectEndsWith.
      attr_accessor :subject_begins_with

      # @return [String] The event subject must end with the pattern provided
      # for trigger to fire. At least one of these must be provided:
      # subjectBeginsWith, subjectEndsWith.
      attr_accessor :subject_ends_with

      # @return The list of event types that cause this trigger to fire.
      attr_accessor :events

      # @return [String] The ARM resource ID of the Azure Event Grid Topic.
      attr_accessor :scope


      #
      # Mapper for CustomEventsTrigger class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CustomEventsTrigger',
          type: {
            name: 'Composite',
            class_name: 'CustomEventsTrigger',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              runtime_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'runtimeState',
                type: {
                  name: 'String'
                }
              },
              annotations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'annotations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              pipelines: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pipelines',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TriggerPipelineReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'TriggerPipelineReference'
                      }
                  }
                }
              },
              subject_begins_with: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.subjectBeginsWith',
                type: {
                  name: 'String'
                }
              },
              subject_ends_with: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.subjectEndsWith',
                type: {
                  name: 'String'
                }
              },
              events: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.events',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              scope: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.scope',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
