# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Delimited text dataset.
    #
    class DelimitedTextDataset < Dataset

      include MsRestAzure


      def initialize
        @type = "DelimitedText"
      end

      attr_accessor :type

      # @return [DatasetLocation] The location of the delimited text storage.
      attr_accessor :location

      # @return The column delimiter. Type: string (or Expression with
      # resultType string).
      attr_accessor :column_delimiter

      # @return The row delimiter. Type: string (or Expression with resultType
      # string).
      attr_accessor :row_delimiter

      # @return The code page name of the preferred encoding. If miss, the
      # default value is UTF-8, unless BOM denotes another Unicode encoding.
      # Refer to the name column of the table in the following link to set
      # supported values:
      # https://msdn.microsoft.com/library/system.text.encoding.aspx. Type:
      # string (or Expression with resultType string).
      attr_accessor :encoding_name

      # @return
      attr_accessor :compression_codec

      # @return The data compression method used for DelimitedText.
      attr_accessor :compression_level

      # @return The quote character. Type: string (or Expression with
      # resultType string).
      attr_accessor :quote_char

      # @return The escape character. Type: string (or Expression with
      # resultType string).
      attr_accessor :escape_char

      # @return When used as input, treat the first row of data as headers.
      # When used as output,write the headers into the output as the first row
      # of data. The default value is false. Type: boolean (or Expression with
      # resultType boolean).
      attr_accessor :first_row_as_header

      # @return The null value string. Type: string (or Expression with
      # resultType string).
      attr_accessor :null_value


      #
      # Mapper for DelimitedTextDataset class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DelimitedText',
          type: {
            name: 'Composite',
            class_name: 'DelimitedTextDataset',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              structure: {
                client_side_validation: true,
                required: false,
                serialized_name: 'structure',
                type: {
                  name: 'Object'
                }
              },
              schema: {
                client_side_validation: true,
                required: false,
                serialized_name: 'schema',
                type: {
                  name: 'Object'
                }
              },
              linked_service_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'linkedServiceName',
                default_value: {},
                type: {
                  name: 'Composite',
                  class_name: 'LinkedServiceReference'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParameterSpecificationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParameterSpecification'
                      }
                  }
                }
              },
              annotations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'annotations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              folder: {
                client_side_validation: true,
                required: false,
                serialized_name: 'folder',
                type: {
                  name: 'Composite',
                  class_name: 'DatasetFolder'
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.location',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'DatasetLocation',
                  class_name: 'DatasetLocation'
                }
              },
              column_delimiter: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.columnDelimiter',
                type: {
                  name: 'Object'
                }
              },
              row_delimiter: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.rowDelimiter',
                type: {
                  name: 'Object'
                }
              },
              encoding_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.encodingName',
                type: {
                  name: 'Object'
                }
              },
              compression_codec: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.compressionCodec',
                type: {
                  name: 'Object'
                }
              },
              compression_level: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.compressionLevel',
                type: {
                  name: 'Object'
                }
              },
              quote_char: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.quoteChar',
                type: {
                  name: 'Object'
                }
              },
              escape_char: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.escapeChar',
                type: {
                  name: 'Object'
                }
              },
              first_row_as_header: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.firstRowAsHeader',
                type: {
                  name: 'Object'
                }
              },
              null_value: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.nullValue',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
