# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Information about a pipeline run.
    #
    class PipelineRun

      include MsRestAzure

      # @return Unmatched properties from the message are deserialized this
      # collection
      attr_accessor :additional_properties

      # @return [String] Identifier of a run.
      attr_accessor :run_id

      # @return [String] Identifier that correlates all the recovery runs of a
      # pipeline run.
      attr_accessor :run_group_id

      # @return [Boolean] Indicates if the recovered pipeline run is the latest
      # in its group.
      attr_accessor :is_latest

      # @return [String] The pipeline name.
      attr_accessor :pipeline_name

      # @return [Hash{String => String}] The full or partial list of parameter
      # name, value pair used in the pipeline run.
      attr_accessor :parameters

      # @return [Hash{String => String}] Run dimensions emitted by Pipeline
      # run.
      attr_accessor :run_dimensions

      # @return [PipelineRunInvokedBy] Entity that started the pipeline run.
      attr_accessor :invoked_by

      # @return [DateTime] The last updated timestamp for the pipeline run
      # event in ISO8601 format.
      attr_accessor :last_updated

      # @return [DateTime] The start time of a pipeline run in ISO8601 format.
      attr_accessor :run_start

      # @return [DateTime] The end time of a pipeline run in ISO8601 format.
      attr_accessor :run_end

      # @return [Integer] The duration of a pipeline run.
      attr_accessor :duration_in_ms

      # @return [String] The status of a pipeline run.
      attr_accessor :status

      # @return [String] The message from a pipeline run.
      attr_accessor :message


      #
      # Mapper for PipelineRun class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PipelineRun',
          type: {
            name: 'Composite',
            class_name: 'PipelineRun',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              run_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'runId',
                type: {
                  name: 'String'
                }
              },
              run_group_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'runGroupId',
                type: {
                  name: 'String'
                }
              },
              is_latest: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'isLatest',
                type: {
                  name: 'Boolean'
                }
              },
              pipeline_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'pipelineName',
                type: {
                  name: 'String'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              run_dimensions: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'runDimensions',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              invoked_by: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'invokedBy',
                type: {
                  name: 'Composite',
                  class_name: 'PipelineRunInvokedBy'
                }
              },
              last_updated: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'lastUpdated',
                type: {
                  name: 'DateTime'
                }
              },
              run_start: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'runStart',
                type: {
                  name: 'DateTime'
                }
              },
              run_end: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'runEnd',
                type: {
                  name: 'DateTime'
                }
              },
              duration_in_ms: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'durationInMs',
                type: {
                  name: 'Number'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              message: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'message',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
