# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # The Amazon S3 settings needed for the interim Amazon S3 when copying from
    # Amazon Redshift with unload. With this, data from Amazon Redshift source
    # will be unloaded into S3 first and then copied into the targeted sink
    # from the interim S3.
    #
    class RedshiftUnloadSettings

      include MsRestAzure

      # @return [LinkedServiceReference] The name of the Amazon S3 linked
      # service which will be used for the unload operation when copying from
      # the Amazon Redshift source.
      attr_accessor :s3linked_service_name

      # @return The bucket of the interim Amazon S3 which will be used to store
      # the unloaded data from Amazon Redshift source. The bucket must be in
      # the same region as the Amazon Redshift source. Type: string (or
      # Expression with resultType string).
      attr_accessor :bucket_name


      #
      # Mapper for RedshiftUnloadSettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RedshiftUnloadSettings',
          type: {
            name: 'Composite',
            class_name: 'RedshiftUnloadSettings',
            model_properties: {
              s3linked_service_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 's3LinkedServiceName',
                default_value: {},
                type: {
                  name: 'Composite',
                  class_name: 'LinkedServiceReference'
                }
              },
              bucket_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'bucketName',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
