# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # A Rest service dataset.
    #
    class RestResourceDataset < Dataset

      include MsRestAzure


      def initialize
        @type = "RestResource"
      end

      attr_accessor :type

      # @return The relative URL to the resource that the RESTful API provides.
      # Type: string (or Expression with resultType string).
      attr_accessor :relative_url

      # @return The HTTP method used to call the RESTful API. The default is
      # GET. Type: string (or Expression with resultType string).
      attr_accessor :request_method

      # @return The HTTP request body to the RESTful API if requestMethod is
      # POST. Type: string (or Expression with resultType string).
      attr_accessor :request_body

      # @return The additional HTTP headers in the request to the RESTful API.
      # Type: string (or Expression with resultType string).
      attr_accessor :additional_headers

      # @return The pagination rules to compose next page requests. Type:
      # string (or Expression with resultType string).
      attr_accessor :pagination_rules


      #
      # Mapper for RestResourceDataset class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RestResource',
          type: {
            name: 'Composite',
            class_name: 'RestResourceDataset',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              structure: {
                client_side_validation: true,
                required: false,
                serialized_name: 'structure',
                type: {
                  name: 'Object'
                }
              },
              schema: {
                client_side_validation: true,
                required: false,
                serialized_name: 'schema',
                type: {
                  name: 'Object'
                }
              },
              linked_service_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'linkedServiceName',
                default_value: {},
                type: {
                  name: 'Composite',
                  class_name: 'LinkedServiceReference'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParameterSpecificationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParameterSpecification'
                      }
                  }
                }
              },
              annotations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'annotations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              folder: {
                client_side_validation: true,
                required: false,
                serialized_name: 'folder',
                type: {
                  name: 'Composite',
                  class_name: 'DatasetFolder'
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              relative_url: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.relativeUrl',
                type: {
                  name: 'Object'
                }
              },
              request_method: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.requestMethod',
                type: {
                  name: 'Object'
                }
              },
              request_body: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.requestBody',
                type: {
                  name: 'Object'
                }
              },
              additional_headers: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.additionalHeaders',
                type: {
                  name: 'Object'
                }
              },
              pagination_rules: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.paginationRules',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
