# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # A copy activity Rest service Sink.
    #
    class RestSink < CopySink

      include MsRestAzure


      def initialize
        @type = "RestSink"
      end

      attr_accessor :type

      # @return The HTTP method used to call the RESTful API. The default is
      # POST. Type: string (or Expression with resultType string).
      attr_accessor :request_method

      # @return The additional HTTP headers in the request to the RESTful API.
      # Type: string (or Expression with resultType string).
      attr_accessor :additional_headers

      # @return The timeout (TimeSpan) to get an HTTP response. It is the
      # timeout to get a response, not the timeout to read response data.
      # Default value: 00:01:40. Type: string (or Expression with resultType
      # string), pattern: ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).
      attr_accessor :http_request_timeout

      # @return The time to await before sending next request, in milliseconds
      attr_accessor :request_interval

      # @return Http Compression Type to Send data in compressed format with
      # Optimal Compression Level, Default is None. And The Only Supported
      # option is Gzip.
      attr_accessor :http_compression_type


      #
      # Mapper for RestSink class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RestSink',
          type: {
            name: 'Composite',
            class_name: 'RestSink',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              write_batch_size: {
                client_side_validation: true,
                required: false,
                serialized_name: 'writeBatchSize',
                type: {
                  name: 'Object'
                }
              },
              write_batch_timeout: {
                client_side_validation: true,
                required: false,
                serialized_name: 'writeBatchTimeout',
                type: {
                  name: 'Object'
                }
              },
              sink_retry_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sinkRetryCount',
                type: {
                  name: 'Object'
                }
              },
              sink_retry_wait: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sinkRetryWait',
                type: {
                  name: 'Object'
                }
              },
              max_concurrent_connections: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxConcurrentConnections',
                type: {
                  name: 'Object'
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              request_method: {
                client_side_validation: true,
                required: false,
                serialized_name: 'requestMethod',
                type: {
                  name: 'Object'
                }
              },
              additional_headers: {
                client_side_validation: true,
                required: false,
                serialized_name: 'additionalHeaders',
                type: {
                  name: 'Object'
                }
              },
              http_request_timeout: {
                client_side_validation: true,
                required: false,
                serialized_name: 'httpRequestTimeout',
                type: {
                  name: 'Object'
                }
              },
              request_interval: {
                client_side_validation: true,
                required: false,
                serialized_name: 'requestInterval',
                type: {
                  name: 'Object'
                }
              },
              http_compression_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'httpCompressionType',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
