# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # The settings that will be leveraged for Sql source partitioning.
    #
    class SqlPartitionSettings

      include MsRestAzure

      # @return The name of the column in integer or datetime type that will be
      # used for proceeding partitioning. If not specified, the primary key of
      # the table is auto-detected and used as the partition column. Type:
      # string (or Expression with resultType string).
      attr_accessor :partition_column_name

      # @return The maximum value of the partition column for partition range
      # splitting. This value is used to decide the partition stride, not for
      # filtering the rows in table. All rows in the table or query result will
      # be partitioned and copied. Type: string (or Expression with resultType
      # string).
      attr_accessor :partition_upper_bound

      # @return The minimum value of the partition column for partition range
      # splitting. This value is used to decide the partition stride, not for
      # filtering the rows in table. All rows in the table or query result will
      # be partitioned and copied. Type: string (or Expression with resultType
      # string).
      attr_accessor :partition_lower_bound


      #
      # Mapper for SqlPartitionSettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SqlPartitionSettings',
          type: {
            name: 'Composite',
            class_name: 'SqlPartitionSettings',
            model_properties: {
              partition_column_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'partitionColumnName',
                type: {
                  name: 'Object'
                }
              },
              partition_upper_bound: {
                client_side_validation: true,
                required: false,
                serialized_name: 'partitionUpperBound',
                type: {
                  name: 'Object'
                }
              },
              partition_lower_bound: {
                client_side_validation: true,
                required: false,
                serialized_name: 'partitionLowerBound',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
